/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package rs.ds.trans.example3.service.impl;

import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import rs.ds.trans.example3.domen.Company;
import rs.ds.trans.example3.repository.CompanyRepository;
import rs.ds.trans.example3.service.CompanyService;

/**
 *
 * @author user
 */
@Service(value = "companyService")
@Transactional
public class CompanyServiceImpl implements CompanyService {

    @Autowired
    private CompanyRepository companyRepository;

    public CompanyServiceImpl() {
        System.out.println("Constructor CompanyServiceImpl....");
    }

    @Transactional(readOnly = true)
    @Override
    public List<Company> findAll() {
        return companyRepository.findAll();
    }

     
    @Override
    //u okviru tekuce, ako ne onda otvori novu
    @Transactional(propagation = Propagation.REQUIRED)   
    
    //uvek nova
    //@Transactional(propagation = Propagation.REQUIRES_NEW)    
    public Company saveCompany(Company company) {
        return companyRepository.save(company);
    }
}
