package rs.telenor.di.repository.impl;
import javax.inject.Named;
import javax.inject.Singleton;
import rs.telenor.di.domen.Book;
import rs.telenor.di.qualifier.Repository;
import rs.telenor.di.repository.IRepository;

@Singleton
//@Named(value ="databaseRepository" )
@Repository (RepoType = Repository.RepoType.DATABASE)
public class DatabaseRepository implements IRepository{

    public DatabaseRepository() {
        System.out.println("rs.telenor.di.repository.impl.DatabaseRepository.<init>()");
    }
    
     @Override
     public void save(Book book){
        System.out.println("The book ["+book+"] is saved in the DATABASE!");
    }
}
